Index: src/backend/catalog/heap.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/heap.c,v
retrieving revision 1.203
diff -c -r1.203 heap.c
*** src/backend/catalog/heap.c	2002/05/22 15:35:43	1.203
--- src/backend/catalog/heap.c	2002/06/15 16:37:54
***************
*** 36,47 ****
  #include "catalog/heap.h"
  #include "catalog/index.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_attrdef.h"
  #include "catalog/pg_inherits.h"
! #include "catalog/pg_relcheck.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
- #include "commands/comment.h"
  #include "commands/trigger.h"
  #include "miscadmin.h"
  #include "nodes/makefuncs.h"
--- 36,49 ----
  #include "catalog/heap.h"
  #include "catalog/index.h"
  #include "catalog/indexing.h"
+ #include "catalog/namespace.h"
  #include "catalog/pg_attrdef.h"
+ #include "catalog/pg_constraint.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_inherits.h"
! #include "catalog/pg_namespace.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
  #include "miscadmin.h"
  #include "nodes/makefuncs.h"
***************
*** 69,76 ****
  					char relkind, bool relhasoids);
  static void DeleteAttributeTuples(Relation rel);
  static void DeleteRelationTuple(Relation rel);
- static void DeleteTypeTuple(Relation rel);
- static void RelationRemoveIndexes(Relation relation);
  static void RelationRemoveInheritance(Relation relation);
  static void AddNewRelationType(const char *typeName,
  							   Oid typeNamespace,
--- 71,76 ----
***************
*** 220,225 ****
--- 220,227 ----
  	bool		nailme = false;
  	RelFileNode	rnode;
  	Relation	rel;
+ 	ObjectAddress	myself,
+ 					dependee;
  
  	/*
  	 * sanity checks
***************
*** 302,307 ****
--- 304,327 ----
  	if (storage_create)
  		heap_storage_create(rel);
  
+ 	/*
+ 	 * Store constraints which the entire table, not strictly 
+ 	 * a column, depends on.  Currently this is only the namespace
+ 	 * within which the relation resides.
+ 	 */
+ 	myself.classId = RelOid_pg_class;
+ 	myself.objectId = relid;
+ 	myself.objectSubId = 0;
+ 
+ 	dependee.classId = GetSysCacheOid(RELNAMENSP,
+ 									  CStringGetDatum(NamespaceRelationName),
+ 									  ObjectIdGetDatum(PG_CATALOG_NAMESPACE),
+ 									  0, 0);
+ 
+ 	dependee.objectId = relnamespace;
+ 	dependee.objectSubId = 0;
+ 	dependCreate(&myself, &dependee, true);
+ 
  	return rel;
  }
  
***************
*** 835,861 ****
  	heap_close(catalogRelation, RowExclusiveLock);
  }
  
- /*
-  *		RelationRemoveIndexes
-  */
- static void
- RelationRemoveIndexes(Relation relation)
- {
- 	List	   *indexoidlist,
- 			   *indexoidscan;
- 
- 	indexoidlist = RelationGetIndexList(relation);
  
- 	foreach(indexoidscan, indexoidlist)
- 	{
- 		Oid			indexoid = lfirsti(indexoidscan);
- 
- 		index_drop(indexoid);
- 	}
- 
- 	freeList(indexoidlist);
- }
- 
  /* --------------------------------
   *		DeleteRelationTuple
   *
--- 855,861 ----
***************
*** 1049,1172 ****
  	heap_close(pg_attribute_desc, RowExclusiveLock);
  }
  
- /* --------------------------------
-  *		DeleteTypeTuple
-  *
-  *		If the user attempts to destroy a relation and there
-  *		exists attributes in other relations of type
-  *		"relation we are deleting", then we have to do something
-  *		special.  presently we disallow the destroy.
-  * --------------------------------
-  */
- static void
- DeleteTypeTuple(Relation rel)
- {
- 	Relation	pg_type_desc;
- 	HeapScanDesc pg_type_scan;
- 	Relation	pg_attribute_desc;
- 	HeapScanDesc pg_attribute_scan;
- 	ScanKeyData key;
- 	ScanKeyData attkey;
- 	HeapTuple	tup;
- 	HeapTuple	atttup;
- 	Oid			typoid;
- 
- 	/*
- 	 * open pg_type
- 	 */
- 	pg_type_desc = heap_openr(TypeRelationName, RowExclusiveLock);
- 
- 	/*
- 	 * create a scan key to locate the type tuple corresponding to this
- 	 * relation.
- 	 */
- 	ScanKeyEntryInitialize(&key, 0,
- 						   Anum_pg_type_typrelid,
- 						   F_OIDEQ,
- 						   ObjectIdGetDatum(RelationGetRelid(rel)));
- 
- 	pg_type_scan = heap_beginscan(pg_type_desc,
- 								  SnapshotNow,
- 								  1,
- 								  &key);
- 
- 	/*
- 	 * use heap_getnext() to fetch the pg_type tuple.  If this tuple is
- 	 * not valid then something's wrong.
- 	 */
- 	tup = heap_getnext(pg_type_scan, ForwardScanDirection);
- 
- 	if (!HeapTupleIsValid(tup))
- 	{
- 		heap_endscan(pg_type_scan);
- 		heap_close(pg_type_desc, RowExclusiveLock);
- 		elog(ERROR, "DeleteTypeTuple: type \"%s\" does not exist",
- 			 RelationGetRelationName(rel));
- 	}
- 
- 	/*
- 	 * now scan pg_attribute.  if any other relations have attributes of
- 	 * the type of the relation we are deleteing then we have to disallow
- 	 * the deletion.  should talk to stonebraker about this.  -cim 6/19/90
- 	 */
- 	typoid = tup->t_data->t_oid;
- 
- 	pg_attribute_desc = heap_openr(AttributeRelationName, RowExclusiveLock);
- 
- 	ScanKeyEntryInitialize(&attkey,
- 						   0,
- 						   Anum_pg_attribute_atttypid,
- 						   F_OIDEQ,
- 						   ObjectIdGetDatum(typoid));
- 
- 	pg_attribute_scan = heap_beginscan(pg_attribute_desc,
- 									   SnapshotNow,
- 									   1,
- 									   &attkey);
- 
- 	/*
- 	 * try and get a pg_attribute tuple.  if we succeed it means we can't
- 	 * delete the relation because something depends on the schema.
- 	 */
- 	atttup = heap_getnext(pg_attribute_scan, ForwardScanDirection);
- 
- 	if (HeapTupleIsValid(atttup))
- 	{
- 		Oid			relid = ((Form_pg_attribute) GETSTRUCT(atttup))->attrelid;
- 
- 		heap_endscan(pg_attribute_scan);
- 		heap_close(pg_attribute_desc, RowExclusiveLock);
- 		heap_endscan(pg_type_scan);
- 		heap_close(pg_type_desc, RowExclusiveLock);
- 
- 		elog(ERROR, "DeleteTypeTuple: column of type %s exists in relation %u",
- 			 RelationGetRelationName(rel), relid);
- 	}
- 	heap_endscan(pg_attribute_scan);
- 	heap_close(pg_attribute_desc, RowExclusiveLock);
- 
- 	/*
- 	 * Ok, it's safe so we delete the relation tuple from pg_type and
- 	 * finish up.
- 	 */
- 	simple_heap_delete(pg_type_desc, &tup->t_self);
- 
- 	heap_endscan(pg_type_scan);
- 	heap_close(pg_type_desc, RowExclusiveLock);
- }
- 
  /* ----------------------------------------------------------------
   *		heap_drop_with_catalog	- removes all record of named relation from catalogs
   *
   *		1)	open relation, check for existence, etc.
   *		2)	remove inheritance information
!  *		3)	remove indexes
!  *		4)	remove pg_class tuple
!  *		5)	remove pg_attribute tuples and related descriptions
!  *		6)	remove pg_description tuples
!  *		7)	remove pg_type tuples
!  *		8)	RemoveConstraints ()
!  *		9)	unlink relation
   *
   * old comments
   *		Except for vital relations, removes relation from
--- 1049,1064 ----
  	heap_close(pg_attribute_desc, RowExclusiveLock);
  }
  
  /* ----------------------------------------------------------------
   *		heap_drop_with_catalog	- removes all record of named relation from catalogs
   *
   *		1)	open relation, check for existence, etc.
   *		2)	remove inheritance information
!  *		3)	remove pg_class tuple
!  *		4)	remove pg_attribute tuples and related descriptions
!  *		5)	remove pg_description tuples
!  *		6)  Let dependDelete() do it's work.
!  *		7)	unlink relation
   *
   * old comments
   *		Except for vital relations, removes relation from
***************
*** 1187,1203 ****
   */
  void
  heap_drop_with_catalog(Oid rid,
! 					   bool allow_system_table_mods)
  {
  	Relation	rel;
- 	Oid			toasttableOid;
  	int			i;
  
  	/*
  	 * Open and lock the relation.
  	 */
  	rel = heap_open(rid, AccessExclusiveLock);
- 	toasttableOid = rel->rd_rel->reltoastrelid;
  
  	/*
  	 * prevent deletion of system relations
--- 1079,1098 ----
   */
  void
  heap_drop_with_catalog(Oid rid,
! 					   bool allow_system_table_mods,
! 					   int behavior)
  {
  	Relation	rel;
  	int			i;
+ 	HeapTuple	tuple;
+ 	int			natts;
+ 	Oid			relHasOids;
+ 	ObjectAddress	myself;
  
  	/*
  	 * Open and lock the relation.
  	 */
  	rel = heap_open(rid, AccessExclusiveLock);
  
  	/*
  	 * prevent deletion of system relations
***************
*** 1217,1260 ****
  			 i);
  
  	/*
- 	 * remove rules if necessary
- 	 */
- 	if (rel->rd_rules != NULL)
- 		RelationRemoveRules(rid);
- 
- 	/* triggers */
- 	RelationRemoveTriggers(rel);
- 
- 	/*
  	 * remove inheritance information
  	 */
  	RelationRemoveInheritance(rel);
  
  	/*
! 	 * remove indexes if necessary
  	 */
! 	RelationRemoveIndexes(rel);
  
  	/*
! 	 * delete attribute tuples
  	 */
! 	DeleteAttributeTuples(rel);
  
  	/*
! 	 * delete comments, statistics, and constraints
  	 */
! 	DeleteComments(rid, RelOid_pg_class);
  
  	RemoveStatistics(rel);
  
  	RemoveConstraints(rel);
  
  	/*
- 	 * delete type tuple
- 	 */
- 	DeleteTypeTuple(rel);
- 
- 	/*
  	 * delete relation tuple
  	 */
  	DeleteRelationTuple(rel);
--- 1112,1167 ----
  			 i);
  
  	/*
  	 * remove inheritance information
  	 */
  	RelationRemoveInheritance(rel);
  
  	/*
! 	 * Deal with dependencies
! 	 *
! 	 * Take care of any attributes first, then the main object
! 	 * last when objectSubId = 0.  Ignore system attributes.
  	 */
! 	tuple = SearchSysCache(RELOID, rid, 0, 0, 0);
! 	if (!HeapTupleIsValid(tuple))
! 		elog(ERROR, "Relation %s doesn't exist", RelationGetRelationName(rel));
! 
! 	natts = ((Form_pg_class) GETSTRUCT(tuple))->relnatts;
! 	relHasOids = ((Form_pg_class) GETSTRUCT(tuple))->relnatts;
  
+ 	/* Must free before calling dependDelete */
+ 	ReleaseSysCache(tuple);
+ 
  	/*
! 	 * Drop in decending order so the table is handled after all
! 	 * of its columns.
! 	 *
! 	 * Oid column first due to abilities like Primary Key on Oid.
  	 */
! 	myself.classId = RelOid_pg_class;
! 	myself.objectId = rid;
! 	if (relHasOids)
! 	{
! 		myself.objectSubId = ObjectIdAttributeNumber;
! 		dependDelete(&myself, behavior);
! 	}
! 
! 	for (i = natts; i >= 0; i--)
! 	{
! 		myself.objectSubId = i;
! 		dependDelete(&myself, behavior);
! 	}
  
  	/*
! 	 * delete attribute tuples
  	 */
! 	DeleteAttributeTuples(rel);
  
  	RemoveStatistics(rel);
  
  	RemoveConstraints(rel);
  
  	/*
  	 * delete relation tuple
  	 */
  	DeleteRelationTuple(rel);
***************
*** 1276,1285 ****
  	 * flush the relation from the relcache
  	 */
  	RelationForgetRelation(rid);
- 
- 	/* If it has a toast table, recurse to get rid of that too */
- 	if (OidIsValid(toasttableOid))
- 		heap_drop_with_catalog(toasttableOid, true);
  }
  
  
--- 1183,1188 ----
***************
*** 1374,1384 ****
  {
  	Node	   *expr;
  	char	   *ccsrc;
! 	Relation	rcrel;
! 	Relation	idescs[Num_pg_relcheck_indices];
! 	HeapTuple	tuple;
! 	Datum		values[4];
! 	static char nulls[4] = {' ', ' ', ' ', ' '};
  
  	/*
  	 * Convert condition to a normal boolean expression tree.
--- 1277,1287 ----
  {
  	Node	   *expr;
  	char	   *ccsrc;
! 	List	   *varList;
! 	List	   *vl;
! 	int			i = 0;
! 	int			keycount = 0;
! 	AttrNumber *attNos;
  
  	/*
  	 * Convert condition to a normal boolean expression tree.
***************
*** 1394,1420 ****
  											RelationGetRelid(rel)),
  							   false);
  
! 	values[Anum_pg_relcheck_rcrelid - 1] = RelationGetRelid(rel);
! 	values[Anum_pg_relcheck_rcname - 1] = DirectFunctionCall1(namein,
! 												CStringGetDatum(ccname));
! 	values[Anum_pg_relcheck_rcbin - 1] = DirectFunctionCall1(textin,
! 												 CStringGetDatum(ccbin));
! 	values[Anum_pg_relcheck_rcsrc - 1] = DirectFunctionCall1(textin,
! 												 CStringGetDatum(ccsrc));
! 	rcrel = heap_openr(RelCheckRelationName, RowExclusiveLock);
! 	tuple = heap_formtuple(rcrel->rd_att, values, nulls);
! 	simple_heap_insert(rcrel, tuple);
! 	CatalogOpenIndices(Num_pg_relcheck_indices, Name_pg_relcheck_indices,
! 					   idescs);
! 	CatalogIndexInsert(idescs, Num_pg_relcheck_indices, rcrel, tuple);
! 	CatalogCloseIndices(Num_pg_relcheck_indices, idescs);
! 	heap_close(rcrel, RowExclusiveLock);
! 
! 	pfree(DatumGetPointer(values[Anum_pg_relcheck_rcname - 1]));
! 	pfree(DatumGetPointer(values[Anum_pg_relcheck_rcbin - 1]));
! 	pfree(DatumGetPointer(values[Anum_pg_relcheck_rcsrc - 1]));
! 	heap_freetuple(tuple);
  	pfree(ccsrc);
  }
  
  /*
--- 1297,1334 ----
  											RelationGetRelid(rel)),
  							   false);
  
! 	/* Find columns of rel that are used in ccbin */
! 	varList = pull_var_clause(expr, false);
! 	foreach(vl, varList)
! 		keycount++;
! 
! 	attNos = (AttrNumber *) palloc(keycount * sizeof(AttrNumber));
! 	foreach(vl, varList)
! 	{
! 		Var *var = (Var *) lfirsti(vl);
! 
! 		attNos[i++] = var->varattno;
! 	}
! 
! 	/* Create the Check Constraint */
! 	constraintCreate(RelationGetRelid(rel), /* Relation the constraint is on */
! 					 ccname, 	/* Constraint Name */
! 					 CONSTRAINT_CHECK, /* Constraint Type */
! 					 false, 	/* Is Derrerable */
! 					 false,		/* Is Deferred */
! 					 attNos,	/* List of attrributes in the constraint */
! 					 keycount,	/* Number of attributes in the constraint */
! 					 NULL,		/* Foreign Key fields (6) */
! 					 NULL,
! 					 NULL,
! 					 NULL,
! 					 NULL,
! 					 NULL,
! 					 ccbin,		/* Binary form check constraint */
! 					 ccsrc);	/* Source form check constraint */
! 
  	pfree(ccsrc);
+ 	pfree(attNos);
  }
  
  /*
***************
*** 1539,1683 ****
  	numchecks = numoldchecks;
  	foreach(listptr, rawConstraints)
  	{
! 		Constraint *cdef = (Constraint *) lfirst(listptr);
! 		char	   *ccname;
! 
! 		if (cdef->contype != CONSTR_CHECK || cdef->raw_expr == NULL)
! 			continue;
! 		Assert(cdef->cooked_expr == NULL);
  
! 		/* Check name uniqueness, or generate a new name */
! 		if (cdef->name != NULL)
  		{
! 			int			i;
! 			List	   *listptr2;
  
! 			ccname = cdef->name;
! 			/* Check against old constraints */
! 			for (i = 0; i < numoldchecks; i++)
! 			{
! 				if (strcmp(oldchecks[i].ccname, ccname) == 0)
! 					elog(ERROR, "Duplicate CHECK constraint name: '%s'",
! 						 ccname);
! 			}
! 			/* Check against other new constraints */
! 			foreach(listptr2, rawConstraints)
! 			{
! 				Constraint *cdef2 = (Constraint *) lfirst(listptr2);
  
! 				if (cdef2 == cdef ||
! 					cdef2->contype != CONSTR_CHECK ||
! 					cdef2->raw_expr == NULL ||
! 					cdef2->name == NULL)
! 					continue;
! 				if (strcmp(cdef2->name, ccname) == 0)
! 					elog(ERROR, "Duplicate CHECK constraint name: '%s'",
! 						 ccname);
! 			}
! 		}
! 		else
! 		{
! 			int			i;
! 			int			j;
! 			bool		success;
! 			List	   *listptr2;
! 
! 			ccname = (char *) palloc(NAMEDATALEN);
! 
! 			/* Loop until we find a non-conflicting constraint name */
! 			/* What happens if this loops forever? */
! 			j = numchecks + 1;
! 			do
! 			{
! 				success = true;
! 				snprintf(ccname, NAMEDATALEN, "$%d", j);
  
! 				/* Check against old constraints */
! 				for (i = 0; i < numoldchecks; i++)
  				{
! 					if (strcmp(oldchecks[i].ccname, ccname) == 0)
  					{
! 						success = false;
! 						break;
  					}
- 				}
  
! 				/*
! 				 * Check against other new constraints, if the check
! 				 * hasn't already failed
! 				 */
! 				if (success)
! 				{
! 					foreach(listptr2, rawConstraints)
  					{
! 						Constraint *cdef2 = (Constraint *) lfirst(listptr2);
  
! 						if (cdef2 == cdef ||
! 							cdef2->contype != CONSTR_CHECK ||
! 							cdef2->raw_expr == NULL ||
! 							cdef2->name == NULL)
! 							continue;
! 						if (strcmp(cdef2->name, ccname) == 0)
! 						{
! 							success = false;
  							break;
! 						}
  					}
- 				}
  
! 				++j;
! 			} while (!success);
! 		}
  
! 		/*
! 		 * Transform raw parsetree to executable expression.
! 		 */
! 		expr = transformExpr(pstate, cdef->raw_expr);
  
! 		/*
! 		 * Make sure it yields a boolean result.
! 		 */
! 		expr = coerce_to_boolean(expr, "CHECK");
  
! 		/*
! 		 * Make sure no outside relations are referred to.
! 		 */
! 		if (length(pstate->p_rtable) != 1)
! 			elog(ERROR, "Only relation \"%s\" can be referenced in CHECK constraint expression",
! 				 relname);
  
! 		/*
! 		 * No subplans or aggregates, either...
! 		 */
! 		if (contain_subplans(expr))
! 			elog(ERROR, "cannot use subselect in CHECK constraint expression");
! 		if (contain_agg_clause(expr))
! 			elog(ERROR, "cannot use aggregate function in CHECK constraint expression");
  
! 		/*
! 		 * Might as well try to reduce any constant expressions.
! 		 */
! 		expr = eval_const_expressions(expr);
  
! 		/*
! 		 * Constraints are evaluated with execQual, which expects an
! 		 * implicit-AND list, so convert expression to implicit-AND form.
! 		 * (We could go so far as to convert to CNF, but that's probably
! 		 * overkill...)
! 		 */
! 		expr = (Node *) make_ands_implicit((Expr *) expr);
  
! 		/*
! 		 * Must fix opids in operator clauses.
! 		 */
! 		fix_opids(expr);
  
! 		/*
! 		 * OK, store it.
! 		 */
! 		StoreRelCheck(rel, ccname, nodeToString(expr));
  
! 		numchecks++;
  	}
  
  	/*
--- 1453,1673 ----
  	numchecks = numoldchecks;
  	foreach(listptr, rawConstraints)
  	{
! 		Node	   *newConstraint = lfirst(listptr);
  
! 		switch (nodeTag(newConstraint))
  		{
! 			case T_Constraint:
! 				{
! 					Constraint *cdef = (Constraint *) newConstraint;
! 					char	   *ccname = cdef->name;
  
! 					if (cdef->contype != CONSTR_CHECK || cdef->raw_expr == NULL)
! 						continue;
! 					Assert(cdef->cooked_expr == NULL);
! 
! 					/*
! 					 * Transform raw parsetree to executable expression.
! 					 */
! 					expr = transformExpr(pstate, cdef->raw_expr);
! 
! 					/*
! 					 * Make sure it yields a boolean result.
! 					 */
! 					if (exprType(expr) != BOOLOID)
! 						elog(ERROR, "CHECK constraint expression '%s' does not yield boolean result",
! 							 ccname);
! 
! 					/*
! 					 * Make sure no outside relations are referred to.
! 					 */
! 					if (length(pstate->p_rtable) != 1)
! 						elog(ERROR, "Only relation \"%s\" can be referenced in CHECK constraint expression",
! 							 relname);
! 
! 					/*
! 					 * No subplans or aggregates, either...
! 					 */
! 					if (contain_subplans(expr))
! 						elog(ERROR, "cannot use subselect in CHECK constraint expression");
! 					if (contain_agg_clause(expr))
! 						elog(ERROR, "cannot use aggregate function in CHECK constraint expression");
! 
! 					/*
! 					 * Might as well try to reduce any constant expressions.
! 					 */
! 					expr = eval_const_expressions(expr);
! 
! 					/*
! 					 * Constraints are evaluated with execQual, which expects an
! 					 * implicit-AND list, so convert expression to implicit-AND form.
! 					 * (We could go so far as to convert to CNF, but that's probably
! 					 * overkill...)
! 					 */
! 					expr = (Node *) make_ands_implicit((Expr *) expr);
! 
! 					/*
! 					 * Must fix opids in operator clauses.
! 					 */
! 					fix_opids(expr);
! 
! 					/*
! 					 * OK, store it.
! 					 *
! 					 * Will check name uniqueness for us.
! 					 */
! 					StoreRelCheck(rel, ccname, nodeToString(expr));
  
! 					numchecks++;
  
! 					break;
! 				}
! 			case T_FkConstraint:
  				{
! 					FkConstraint *fkconstraint = (FkConstraint *) newConstraint;
! 					Relation	pkrel;
! 					List	   *list;
! 					Oid			conId;
! 					AttrNumber *pkattr = NULL;
! 					AttrNumber *fkattr = NULL;
! 					int			pkcount = 0;
! 					int			fkcount = 0;
! 					int			i;
! 					char		updateType = CONSTRAINT_FKEY_RESTRICT;	/* Defaults kill warnings */
! 					char		deleteType = CONSTRAINT_FKEY_RESTRICT;
! 
! 					/*
! 					 * Grab an exclusive lock on the pk table, so that
! 					 * someone doesn't delete rows out from under us.
! 					 *
! 					 * XXX wouldn't a lesser lock be sufficient?
! 					 */
! 					pkrel = heap_openrv(fkconstraint->pktable,
! 										AccessExclusiveLock);
! 
! 					/*
! 					 * Validity checks
! 					 */
! 					if (pkrel->rd_rel->relkind != RELKIND_RELATION)
! 						elog(ERROR, "referenced table \"%s\" not a relation",
! 							 fkconstraint->pktable->relname);
! 
! 					if (isTempNamespace(RelationGetNamespace(pkrel)) &&
! 						!isTempNamespace(RelationGetNamespace(rel)))
! 						elog(ERROR, "ALTER TABLE / ADD CONSTRAINT: Unable to reference temporary table from permanent table constraint.");
! 
! 					/* Foreign Keyd table AttrNumber array */
! 					foreach(list, fkconstraint->fk_attrs)
! 						fkcount++;
! 
! 					fkattr = (AttrNumber *) palloc(fkcount * sizeof(AttrNumber));
! 					i = 0;
! 					foreach(list, fkconstraint->fk_attrs)
  					{
! 						Ident *id = (Ident *) lfirsti(list);
! 
! 						fkattr[i++] = get_attnum(RelationGetRelid(rel), id->name);
  					}
  
! 					/* Foreign Referenced table AttrNumber array */
! 					foreach(list, fkconstraint->pk_attrs)
! 						pkcount++;
! 
! 					pkattr = (AttrNumber *) palloc(pkcount * sizeof(AttrNumber));
! 					i = 0;
! 					foreach(list, fkconstraint->pk_attrs)
  					{
! 						Ident *id = (Ident *) lfirsti(list);
! 
! 						pkattr[i++] = get_attnum(RelationGetRelid(pkrel), id->name);
! 					}
  
! 					/* Find the delete type */
! 					switch ((fkconstraint->actions & FKCONSTR_ON_DELETE_MASK)
! 							>> FKCONSTR_ON_DELETE_SHIFT)
! 					{
! 						case FKCONSTR_ON_KEY_CASCADE:
! 							deleteType = CONSTRAINT_FKEY_CASCADE;
! 							break;
! 
! 						case FKCONSTR_ON_KEY_NOACTION:
! 							deleteType = CONSTRAINT_FKEY_NOACTION;
! 							break;
! 
! 						case FKCONSTR_ON_KEY_RESTRICT:
! 							deleteType = CONSTRAINT_FKEY_RESTRICT;
! 							break;
! 
! 						case FKCONSTR_ON_KEY_SETNULL:
! 							deleteType = CONSTRAINT_FKEY_NULL;
  							break;
! 
! 						case FKCONSTR_ON_KEY_SETDEFAULT:
! 							deleteType = CONSTRAINT_FKEY_DEFAULT;
! 							break;
! 
! 						default:
! 							elog(ERROR, "AlterTableAddConstraint: Foreign key delete type %d unknown",
! 								 fkconstraint->actions);
  					}
  
! 					/* Find the update type */
! 					switch ((fkconstraint->actions & FKCONSTR_ON_UPDATE_MASK)
! 							>> FKCONSTR_ON_UPDATE_SHIFT)
! 					{
  
! 						case FKCONSTR_ON_KEY_CASCADE:
! 							updateType = CONSTRAINT_FKEY_CASCADE;
! 							break;
  
! 						case FKCONSTR_ON_KEY_NOACTION:
! 							updateType = CONSTRAINT_FKEY_NOACTION;
! 							break;
  
! 						case FKCONSTR_ON_KEY_RESTRICT:
! 							updateType = CONSTRAINT_FKEY_RESTRICT;
! 							break;
  
! 						case FKCONSTR_ON_KEY_SETNULL:
! 							updateType = CONSTRAINT_FKEY_NULL;
! 							break;
  
! 						case FKCONSTR_ON_KEY_SETDEFAULT:
! 							updateType = CONSTRAINT_FKEY_DEFAULT;
! 							break;
  
! 						default:
! 							elog(ERROR, "AlterTableAddConstraint: Foreign key update type %d unknown",
! 								 fkconstraint->actions);
! 					}
  
! 					/*
! 					 * Record the Foreign Key constraint
! 					 */
! 					conId = constraintCreate(RelationGetRelid(rel),
! 				 							 fkconstraint->constr_name,
! 				 							 CONSTRAINT_FOREIGN,
! 				 							 fkconstraint->deferrable,
! 				 							 fkconstraint->initdeferred,
! 											 fkattr,
! 											 fkcount,
! 											 RelationGetRelid(pkrel),
! 				 							 pkattr,
! 											 pkcount,
! 											 updateType,
! 											 deleteType,
! 				 							 fkconstraint->match_type,
! 											 NULL,
! 											 NULL);
  
! 
! 					heap_close(pkrel, NoLock);
  
! 					break;
! 				}
! 			default:
! 				elog(ERROR, "AddRelationRawConstraints: Unable to determine type of constraint passed");
! 		}
  	}
  
  	/*
***************
*** 1828,1834 ****
  	return(expr);
  }
  
- 
  static void
  RemoveAttrDefaults(Relation rel)
  {
--- 1818,1823 ----
***************
*** 1853,1996 ****
  }
  
  static void
- RemoveRelChecks(Relation rel)
- {
- 	Relation	rcrel;
- 	HeapScanDesc rcscan;
- 	ScanKeyData key;
- 	HeapTuple	tup;
- 
- 	rcrel = heap_openr(RelCheckRelationName, RowExclusiveLock);
- 
- 	ScanKeyEntryInitialize(&key, 0, Anum_pg_relcheck_rcrelid,
- 						   F_OIDEQ,
- 						   ObjectIdGetDatum(RelationGetRelid(rel)));
- 
- 	rcscan = heap_beginscan(rcrel, SnapshotNow, 1, &key);
- 
- 	while ((tup = heap_getnext(rcscan, ForwardScanDirection)) != NULL)
- 		simple_heap_delete(rcrel, &tup->t_self);
- 
- 	heap_endscan(rcscan);
- 	heap_close(rcrel, RowExclusiveLock);
- 
- }
- 
- /*
-  * Removes all CHECK constraints on a relation that match the given name.
-  * It is the responsibility of the calling function to acquire a lock on
-  * the relation.
-  * Returns: The number of CHECK constraints removed.
-  */
- int
- RemoveCheckConstraint(Relation rel, const char *constrName, bool inh)
- {
- 	Oid			relid;
- 	Relation	rcrel;
- 	TupleDesc	tupleDesc;
- 	TupleConstr *oldconstr;
- 	int			numoldchecks;
- 	int			numchecks;
- 	HeapScanDesc rcscan;
- 	ScanKeyData key[2];
- 	HeapTuple	rctup;
- 	int			rel_deleted = 0;
- 	int			all_deleted = 0;
- 
- 	/* Find id of the relation */
- 	relid = RelationGetRelid(rel);
- 
- 	/*
- 	 * Process child tables and remove constraints of the same name.
- 	 */
- 	if (inh)
- 	{
- 		List	   *child,
- 				   *children;
- 
- 		/* This routine is actually in the planner */
- 		children = find_all_inheritors(relid);
- 
- 		/*
- 		 * find_all_inheritors does the recursive search of the
- 		 * inheritance hierarchy, so all we have to do is process all of
- 		 * the relids in the list that it returns.
- 		 */
- 		foreach(child, children)
- 		{
- 			Oid			childrelid = lfirsti(child);
- 			Relation	inhrel;
- 
- 			if (childrelid == relid)
- 				continue;
- 			inhrel = heap_open(childrelid, AccessExclusiveLock);
- 			all_deleted += RemoveCheckConstraint(inhrel, constrName, false);
- 			heap_close(inhrel, NoLock);
- 		}
- 	}
- 
- 	/*
- 	 * Get number of existing constraints.
- 	 */
- 	tupleDesc = RelationGetDescr(rel);
- 	oldconstr = tupleDesc->constr;
- 	if (oldconstr)
- 		numoldchecks = oldconstr->num_check;
- 	else
- 		numoldchecks = 0;
- 
- 	/* Grab an appropriate lock on the pg_relcheck relation */
- 	rcrel = heap_openr(RelCheckRelationName, RowExclusiveLock);
- 
- 	/*
- 	 * Create two scan keys.  We need to match on the oid of the table the
- 	 * CHECK is in and also we need to match the name of the CHECK
- 	 * constraint.
- 	 */
- 	ScanKeyEntryInitialize(&key[0], 0, Anum_pg_relcheck_rcrelid,
- 						   F_OIDEQ,
- 						   ObjectIdGetDatum(RelationGetRelid(rel)));
- 
- 	ScanKeyEntryInitialize(&key[1], 0, Anum_pg_relcheck_rcname,
- 						   F_NAMEEQ,
- 						   PointerGetDatum(constrName));
- 
- 	/* Begin scanning the heap */
- 	rcscan = heap_beginscan(rcrel, SnapshotNow, 2, key);
- 
- 	/*
- 	 * Scan over the result set, removing any matching entries.  Note that
- 	 * this has the side-effect of removing ALL CHECK constraints that
- 	 * share the specified constraint name.
- 	 */
- 	while ((rctup = heap_getnext(rcscan, ForwardScanDirection)) != NULL)
- 	{
- 		simple_heap_delete(rcrel, &rctup->t_self);
- 		++rel_deleted;
- 		++all_deleted;
- 	}
- 
- 	/* Clean up after the scan */
- 	heap_endscan(rcscan);
- 	heap_close(rcrel, RowExclusiveLock);
- 
- 	if (rel_deleted)
- 	{
- 		/*
- 		 * Update the count of constraints in the relation's pg_class tuple.
- 		 */
- 		numchecks = numoldchecks - rel_deleted;
- 		if (numchecks < 0)
- 			elog(ERROR, "check count became negative");
- 
- 		SetRelationNumChecks(rel, numchecks);
- 	}
- 
- 	/* Return the number of tuples deleted, including all children */
- 	return all_deleted;
- }
- 
- static void
  RemoveConstraints(Relation rel)
  {
  	TupleConstr *constr = rel->rd_att->constr;
--- 1842,1847 ----
***************
*** 2000,2008 ****
  
  	if (constr->num_defval > 0)
  		RemoveAttrDefaults(rel);
- 
- 	if (constr->num_check > 0)
- 		RemoveRelChecks(rel);
  }
  
  static void
--- 1851,1856 ----
Index: src/backend/catalog/index.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/index.c,v
retrieving revision 1.179
diff -c -r1.179 index.c
*** src/backend/catalog/index.c	2002/05/21 22:05:53	1.179
--- src/backend/catalog/index.c	2002/06/15 16:37:58
***************
*** 32,39 ****
--- 32,43 ----
  #include "catalog/heap.h"
  #include "catalog/index.h"
  #include "catalog/indexing.h"
+ #include "catalog/pg_class.h"
+ #include "catalog/pg_constraint.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/pg_index.h"
  #include "catalog/pg_opclass.h"
+ #include "catalog/pg_namespace.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "commands/comment.h"
***************
*** 543,548 ****
--- 547,555 ----
  	bool		shared_relation;
  	Oid			namespaceId;
  	Oid			indexoid;
+ 	ObjectAddress	myself,
+ 					dependee;
+ 	int				i;
  
  	SetReindexProcessing(false);
  
***************
*** 593,599 ****
  	else
  		indexTupDesc = ConstructTupleDescriptor(heapRelation,
  												indexInfo->ii_NumKeyAttrs,
! 											indexInfo->ii_KeyAttrNumbers,
  												classObjectId);
  
  	/*
--- 600,606 ----
  	else
  		indexTupDesc = ConstructTupleDescriptor(heapRelation,
  												indexInfo->ii_NumKeyAttrs,
! 												indexInfo->ii_KeyAttrNumbers,
  												classObjectId);
  
  	/*
***************
*** 630,635 ****
--- 637,705 ----
  	 */
  	UpdateRelationRelation(indexRelation);
  
+ 	myself.classId = RelOid_pg_class;
+ 	myself.objectId = indexoid;
+ 	myself.objectSubId = 0;
+ 
+ 	/*
+ 	 * If this is a unique index, we need to store the constraint
+ 	 * information as well as the dependency on it.
+ 	 */
+ 	if (indexInfo->ii_Unique || primary)
+ 	{
+ 		char		constraintType;
+ 		Oid			conOid;
+ 
+ 		if (primary)
+ 			constraintType = CONSTRAINT_PRIMARY;
+ 		else
+ 			constraintType = CONSTRAINT_UNIQUE;
+ 
+ 		conOid = constraintCreate(heapRelationId,
+ 								  indexRelationName,
+ 								  constraintType,
+ 								  false, /* isDeferrable */
+ 								  false, /* isDeferred */
+ 								  indexInfo->ii_KeyAttrNumbers,
+ 								  indexInfo->ii_NumIndexAttrs,
+ 								  NULL, /* Foreign Key Information */
+ 								  NULL,
+ 								  NULL,
+ 								  NULL,
+ 								  NULL,
+ 								  NULL,
+ 								  NULL, /* Constraint Bin & Src */
+ 								  NULL);
+ 
+ 		dependee.classId = get_relname_relid(ConstraintRelationName, PG_CATALOG_NAMESPACE);
+ 		dependee.objectId = conOid;
+ 		dependee.objectSubId = 0;
+ 
+ 		/* We always cascade index drops with constraint drops */
+ 		dependCreate(&myself, &dependee, true);
+ 	}
+ 
+ 	/* Store dependencies on the attributes */
+ 	for (i = 0; i < indexInfo->ii_NumIndexAttrs; i++)
+ 	{
+ 		dependee.classId = RelOid_pg_class;
+ 		dependee.objectId = heapRelationId;
+ 		dependee.objectSubId = indexInfo->ii_KeyAttrNumbers[i];
+ 
+ 		/* We always cascade index drops with attribute drops */
+ 		dependCreate(&myself, &dependee, true);
+ 	}
+ 
+ 	/* Store the dependency on the function (if appropriate) */
+ 	if (OidIsValid(indexInfo->ii_FuncOid))
+ 	{
+ 		dependee.classId = RelOid_pg_proc;
+ 		dependee.objectId = indexInfo->ii_FuncOid;
+ 		dependee.objectSubId = 0;
+ 
+ 		dependCreate(&myself, &dependee, false);
+ 	}
+ 
  	/*
  	 * We create the disk file for this relation here
  	 */
***************
*** 698,704 ****
   * ----------------------------------------------------------------
   */
  void
! index_drop(Oid indexId)
  {
  	Oid			heapId;
  	Relation	userHeapRelation;
--- 768,774 ----
   * ----------------------------------------------------------------
   */
  void
! index_drop(Oid indexId, int behavior)
  {
  	Oid			heapId;
  	Relation	userHeapRelation;
***************
*** 709,714 ****
--- 779,786 ----
  	HeapTuple	tuple;
  	int16		attnum;
  	int			i;
+ 	
+ 	ObjectAddress	myself;
  
  	Assert(OidIsValid(indexId));
  
***************
*** 736,745 ****
  	 * did check it here, deletion of TOAST tables would fail...
  	 */
  
! 	/*
! 	 * fix DESCRIPTION relation
! 	 */
! 	DeleteComments(indexId, RelOid_pg_class);
  
  	/*
  	 * fix RELATION relation
--- 808,817 ----
  	 * did check it here, deletion of TOAST tables would fail...
  	 */
  
! 	myself.classId = RelOid_pg_class;
! 	myself.objectId = indexId;
! 	myself.objectSubId = 0;
! 	dependDelete(&myself, behavior);
  
  	/*
  	 * fix RELATION relation
